package org.processmining.plugins.declareminer.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.ListCellRenderer;
import javax.swing.border.EmptyBorder;

import org.processmining.plugins.declareminer.visualizing.Cell;

import com.fluxicon.slickerbox.factory.SlickerFactory;

public class ListRendererResult implements ListCellRenderer {

	//private final JCheckBox box;
	private final JLabel label;
	private final JPanel panel;

	public ListRendererResult() {
		SlickerFactory sf = SlickerFactory.instance();
		panel = new JPanel();
		panel.setBackground(new Color(160, 160, 160));
		label = sf.createLabel("");
		//box = sf.createCheckBox("", false);
		panel.setLayout(new BorderLayout());
		//panel.add(bef, BorderLayout.NORTH);
		panel.add(label, BorderLayout.WEST);
		//panel.add(box, BorderLayout.EAST);
		panel.setBorder(new EmptyBorder(3, 2, 3, 0));
	}

	@Override
	public Component getListCellRendererComponent(JList list, Object value, int index, boolean isNa,
			boolean cellHasFocus) {
		// TODO Auto-generated method stub
		boolean na = false;
		Cell c = (Cell) value;
		if(c.getLabel().equals("Activations")){
			label.setForeground(Color.orange);
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize()));
		}else if(c.getLabel().equals("Fulfilments")){
			label.setForeground(Color.orange);
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize()));
		}else if(c.getLabel().equals("Violations")){
			label.setForeground(Color.orange);
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize()));
		}else if(c.getLabel().equals("Conflicts")){
			label.setForeground(Color.orange);
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize()));
		}else if(c.getLabel().equals("Support")){
			label.setForeground(new Color(255,0,0));
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize()));
		}
		else if(c.getLabel().equals("CPIR")){
			label.setForeground(new Color(0,255,0));
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize() ));
		}
		else if(c.getLabel().equals("Activity Support")){
			label.setForeground(new Color(255,255,0));
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize() ));
		}else if(c.getLabel().equals("Balanced Traces")){
			label.setForeground(new Color(255,255,0));
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize() ));
		}else if(c.getLabel().equals("Traces with Missing Complete")){
			label.setForeground(new Color(255,255,0));
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize() ));
		}else if(c.getLabel().equals("Unbalancing Degree (Missing Complete)")){
			label.setForeground(new Color(255,255,0));
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize() ));
		}else if(c.getLabel().equals("Traces with Missing Start")){
			label.setForeground(new Color(255,255,0));
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize() ));
		}else if(c.getLabel().equals("Unbalancing Degree (Missing Start)")){
			label.setForeground(new Color(255,255,0));
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize() ));
		}
		//if(c.getLabel().equals("Support Consequent")){
		//	label.setForeground(new Color(255,255,0));
		//	label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize() ));
		//}
		else if(c.getLabel().equals("Confidence")){
			label.setForeground(new Color(255,0,255));
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize() ));
		}
		else if(c.getLabel().equals("Interest Factor")){
			label.setForeground(new Color(0,0,255));
			label.setFont(new Font(Font.SANS_SERIF, Font.BOLD, label.getFont().getSize() ));
		}else{
			if(!label.getForeground().equals(Color.white)){
				Float metrvalue = new Float(c.getLabel());
				if(metrvalue>=Float.MAX_VALUE/10.f){
					na = true;
				}
			}
		}
		if(na){
			label.setText("n.a.");
		}else{
			label.setText(c.getLabel());
		}
		return panel;
	}
}
