package org.processmining.plugins.declareminer.importing;

import java.io.InputStream;

import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.plugins.declareminer.visualizing.AssignmentModel;
import org.processmining.plugins.declareminer.visualizing.AssignmentModelView;
import org.processmining.plugins.declareminer.visualizing.AssignmentViewBroker;
import org.processmining.plugins.declareminer.visualizing.DeclareMap;
import org.processmining.plugins.declareminer.visualizing.XMLBrokerFactory;


@Plugin(name = "Import ProM Declare Model", parameterLabels = { "Filename" }, returnLabels = { "ProM Declare Model" }, returnTypes = { DeclareMap.class })
@UIImportPlugin(description = "ProM Declare Model", extensions = { "xml" })
public class DeclareModelImportPlugin extends AbstractImportPlugin {

	protected FileFilter getFileFilter() {
		return new FileNameExtensionFilter("XML files", "xml");
	}

	protected DeclareMap importFromStream(PluginContext context, InputStream input, String filename,
			long fileSizeInBytes) throws Exception {
		context.getFutureResult(0).setLabel("Declare Model imported from " + filename);
		AssignmentViewBroker broker = XMLBrokerFactory.newAssignmentBroker(getFile().getAbsolutePath());
		AssignmentModel model = broker.readAssignment();
		AssignmentModelView view = new AssignmentModelView(model);
		broker.readAssignmentGraphical(model, view);
		org.processmining.plugins.declare.visualizing.AssignmentViewBroker brokerCh = org.processmining.plugins.declare.visualizing.XMLBrokerFactory.newAssignmentBroker(getFile().getAbsolutePath());
		org.processmining.plugins.declare.visualizing.AssignmentModel modelCh = brokerCh.readAssignment();
		org.processmining.plugins.declare.visualizing.AssignmentModelView viewCheck = new org.processmining.plugins.declare.visualizing.AssignmentModelView(modelCh);
		brokerCh.readAssignmentGraphical(modelCh, viewCheck);
		DeclareMap decModel = new DeclareMap(model, modelCh, view,viewCheck, broker, brokerCh);
		System.out.println("No. Constraints: "+model.constraintDefinitionsCount()+"-- No. Activities: "+model.activityDefinitionsCount());
		return decModel;
	}
}